#include "settings.h"
#include "suarttx.h"
#include "touch.h"
#include <avr/power.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include<stdio.h> 

void knight_rider(uint8_t dir)
{
  static uint8_t pattern[] = { 1, 2, 4, 8, 0x10, 0x20, 0x40, 0x80 };
  static uint8_t val = 0;
  if (dir)
  {
    val++;
    if (val > 7)
      val = 0;
  }
  else
  {
    val--;
    if (val > 7)
      val = 7;
  }
  PORTD = ~pattern[val];
  DDRD = 0xFF;
}

char s[100];

int main(void)
{
  clock_prescale_set(clock_div_2);              // 4MHz
  knight_rider(0);
  touch_init();
  sei();
  sputs("Start\n\r", TX_SRAM);
  uint8_t wait = 0;
  while(1)
  {
    if (get_key_press(KEY_LEFT) || get_key_rpt(KEY_LEFT))
      knight_rider(0);
    if (get_key_press(KEY_RIGHT) || get_key_rpt(KEY_RIGHT))
      knight_rider(1);
    _delay_ms(10);
    if (wait++ == 100)
    {
       wait = 0;
       sprintf( s, "zero0: %4d, press0: %4d, zero1: %4d, press1: %4d\n\r",
         touch[0].low>>TOUCH_AVG, (touch[0].val - touch[0].low)>>TOUCH_AVG,
         touch[1].low>>TOUCH_AVG, (touch[1].val - touch[1].low)>>TOUCH_AVG);
       sputs(s, TX_SRAM);
    }
  }
}
